Overview | Package | Class | Tree | Deprecated | Index | Help
| Oracle TopLink API Reference 10g Release 3 (10.1.3) B13698-01
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## oracle.toplink.history
Class AsOfClause

`java.lang.Object
oracle.toplink.history.AsOfClause`

All Implemented Interfaces:
  java.io.Serializable

Direct Known Subclasses:
  AsOfSCNClause

public class AsOfClause
extends java.lang.Object
implements java.io.Serializable

Purpose:Wraps an immutable value for a past time. A session, query, or expression can be as of a past time.

For Oracle 9R2 Flasback corresponds to the sub clause which appears between the table and alias name in the FROM clause: `SELECT ... FROM EMPLOYEE AS OF TIMESTAMP (value) t0, ...`

For generic historical schema support, a special criteria can be added to the where clause for each table in a select: `((t0.ROW_START <= value) AND ((t0.END IS NULL) OR (t1.END > value)))`

Responsibilities:

- By default AsOfClause is a timestamp. To specify a system change number use AsOfSCNClause.
- For Oracle 9R2 Flashback prints the correct AS OF clause before the alias name in the FROM clause.
- Read-only: the wrapped value can not change.

Since:
  OracleAS TopLink 10g (10.0.3)
See Also:
  `Expression.asOf(AsOfClause)`, `oracle.toplink.queryframework.ObjectLevelReadQuery#asOf(AsOfClause)`, `oracle.toplink.sessions.Session#acquireSessionAsOf(AsOfClause)`, `HistoryPolicy`, Serialized Form

Field Summary
`static AsOfClause` | `NO_CLAUSE`

Constructor Summary
`AsOfClause(java.util.Calendar calendar)`
`AsOfClause(java.util.Date date)`
`AsOfClause(Expression expression)`
`AsOfClause(long time)`
`AsOfClause(java.lang.Long time)`
`AsOfClause(java.sql.Timestamp timestamp)`

Method Summary
`java.lang.Object` | `getValue()` PUBLIC: The past time represented by the receiver.
`boolean` | `isAsOfSCNClause()` PUBLIC: Indicates that `value` is a system change number or an expression evaluating to one.
`boolean` | `isUniversal()` PUBLIC: Answers if this is a UniversalAsOfClause, one to be applied to the entire selection criteria.
`java.lang.String` | `toString()`

Methods inherited from class java.lang.Object
`equals, getClass, hashCode, notify, notifyAll, wait, wait, wait`

Field Detail

### NO_CLAUSE

    public static final AsOfClause NO_CLAUSE

Constructor Detail

### AsOfClause

    public AsOfClause(java.util.Date date)

### AsOfClause

    public AsOfClause(java.sql.Timestamp timestamp)

### AsOfClause

    public AsOfClause(java.util.Calendar calendar)

### AsOfClause

    public AsOfClause(long time)

### AsOfClause

    public AsOfClause(java.lang.Long time)

### AsOfClause

    public AsOfClause(Expression expression)

Method Detail

### getValue

    public java.lang.Object getValue()

  PUBLIC: The past time represented by the receiver. Either a timestamp, a system change number, or an Expression.

### isAsOfSCNClause

    public boolean isAsOfSCNClause()

  PUBLIC: Indicates that `value` is a system change number or an expression evaluating to one.

  In Oracle the value will have to be printed using the syntax `AS OF SCN(value)` instead of `AS OF TIMESTAMP(value)`.

  See Also:
    `AsOfSCNClause`

### isUniversal

    public boolean isUniversal()

  PUBLIC: Answers if this is a UniversalAsOfClause, one to be applied to the entire selection criteria.

  Used when a query is made as of a past time.

### toString

    public java.lang.String toString()

Overview | Package | Class | Tree | Deprecated | Index | Help
| Copyright © 1998, 2006, Oracle. All Rights Reserved.
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD